/* $Id: nonblock.c,v 1.1 2002/02/05 22:49:02 poettering Exp $
 *
 * This file is part of libshbuf. 
 *
 * asd is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 *
 * asd is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with libshbuf; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
 */

#include <fcntl.h>

#include "nonblock.h"

int set_nonblocking(int fd, int b) {
    int flags;

    if ((flags = fcntl(fd, F_GETFL, 0)) == -1)
        return 0;

    if (b)
        flags |= O_NONBLOCK;
    else
        flags = flags & ~O_NONBLOCK;

    return fcntl(fd, F_SETFL, flags) != -1;
}
